#ifndef CRYPTDEVICE_H
#define CRYPTDEVICE_H

#include <qiodevice.h>
#include <qvaluestack.h>

class CryptDevice : public QIODevice
{
public:
    CryptDevice(QIODevice *underlyingDevice);

    bool open(int mode);
    void close();
    void flush();
    Offset size() const;
    Offset at() const;
    bool at(Offset pos);
    Q_LONG readBlock(char *data, Q_ULONG maxSize);
    Q_LONG writeBlock(const char *data, Q_ULONG size);
    int	getch();
    int	putch(int ch);
    int	ungetch(int ch);

private:
    QIODevice *underlyingDevice;
    QValueStack<char> ungetchBuffer;
};

#endif
